var mediaplayer = null;
var lastElement = null;
var songlist = new Array();

function iTunesInit (e) {
	var trs = document.getElementsByTagName('tr');
	for (var i=1; i < trs.length; i++) {
		trs[i].addEventListener("click", iTunesClick, false);
	};

	if (document.getElementById('prevbutton')) // Index page does not have controls
	{
		document.getElementById('prevbutton').addEventListener('click', prev, false);
		document.getElementById('nextbutton').addEventListener('click', next, false);
		document.getElementById('shuffle').addEventListener('click', shuffle, false);
	
		mediaplayer = new MediaPlayer(document.getElementById("player"));
		mediaplayer.songEndedCallback = next;
	}
	
	if (document.getElementById('loading')) 
	{
		setTimeout(function() {
			var req = new AsyncRequest();
			var playlist = window.location.toString().lastPathComponent();
			req.action = incrementallyLoadSongs;
			req.userdata = {'playlist': playlist, 'page': 0};
			req.fetch('/music/load/' + playlist + '/0');
		}, 10);
	}
}

function incrementallyLoadSongs (e, req) {
	var songs = eval('(' + req.request.responseText + ')');
	var table = document.getElementsByTagName('table')[0];
	if (songs.length > 0) {
		var stripe = true;
		for (var i=0; i < songs.length; i++) {
			var song = songs[i];
			var tr = document.createElement("tr");
			var td = document.createElement("td");
			var name = document.createElement("td");
			var artist = document.createElement("td");
			var album = document.createElement("td");
			var genre = document.createElement("td");
			
			name.appendChild(document.createTextNode(song['Name'] ? song['Name'] : ""));
			artist.appendChild(document.createTextNode(song['Artist'] ? song['Artist'] : ""));
			album.appendChild(document.createTextNode(song['Album'] ? song['Album'] : ""));
			genre.appendChild(document.createTextNode(song['Genre'] ? song['Genre'] : ""));
			
			tr.setAttribute("title", song['Location']);
			tr.addEvent('click', iTunesClick);
			tr.appendChild(td);
			tr.appendChild(name);
			tr.appendChild(artist);
			tr.appendChild(album);
			tr.appendChild(genre);
			table.appendChild(tr);
			
			if (stripe) tr.className = 'striped';
			stripe = !stripe;
		};
		// Begin next request
		var nReq = new AsyncRequest();
		var userdata = req.userdata;
		userdata['page'] = userdata['page'] + 1;
		nReq.action = incrementallyLoadSongs;
		nReq.userdata = userdata;
		nReq.fetch('/music/load/' + userdata['playlist'] + '/' + userdata['page']);
	}
	else
	{
		var div = document.getElementById('loading');
		div.parentNode.removeChild(div);
	}
}

function shuffle () {
	var trs = document.getElementsByTagName('tr');
	for (var i=1; i < trs.length; i++) {
		var tr = trs[i];
		var idx = Math.floor(Math.random()*trs.length);
		if (idx==0) idx++;
		var swap = trs[idx];
		tr.swapWithNode(swap);
	};
	document.getElementsByTagName('table')[0].stripe();
}

function startPlayer () {
	var time = 0;
	var f = function () {
		if (mediaplayer.isPlayable())
		{
			if (time != mediaplayer.time()) return;
			mediaplayer.play();
			time = mediaplayer.time();
		}
		setTimeout(f, 500);
	}
	f();
}

function setSong (song) {
	if (!song) return;
	
	mediaplayer.setSong(song['uri']);
	startPlayer();
	
	var player = document.getElementById('player');
	var h1 = player.getElementsByTagName('h1')[0];
	var h2 = player.getElementsByTagName('h2')[0];
	var h3 = player.getElementsByTagName('h3')[0];
	
	h1.innerHTML = song['title'];
	h2.innerHTML = song['artist'];
	h3.innerHTML = song['album'];
	
	// Expand if next song is actually a movie
	var media = mediaplayer.media();
	if (song['uri'].search('(mov)|(mp4)|(m4v)|(flv)|(swf)|(avi)|(divx)|(xvid)|(mpeg)|(mpg)$') > 0 && (media.style.height == '1em' || media.style.height == ''))
	{
		media.style.width = "640px";
		media.style.height = "480px";
	}
	else if (media.style.height != '1em')
	{
		media.style.height = '';
		media.style.width = '';
	}
}

function prev () {
	setSong(songlist.pop());
}

function next () {
	var nextElement = null;
	var trs = document.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		var elem = trs[i];
		if (elem == lastElement)
		{
			if (i == trs.length-1) nextElement = trs[1];
			else nextElement = trs[i+1];
			break;
		}
	};
	
	var uri = '/music/file/'+nextElement.title.replace('file://localhost/', '');
	var title = artist = album = genre = '';
	try { title = nextElement.childNodes[1].firstChild.data; } catch(e) {}
	try { artist = nextElement.childNodes[2].firstChild.data; } catch (e) {}
	try { album = nextElement.childNodes[3].firstChild.data; } catch (e) {}
 	try { genre = nextElement.childNodes[4].firstChild.data; } catch (e) {}

	songlist[songlist.length] = {'uri':uri, 'title': title, 'artist': artist, 'album': album, 'genre': genre};	
	setSong(songlist[songlist.length-1]);
	lastElement = nextElement;
}

function playpause (e) {
	mediaplayer.play();
}

function iTunesClick (e) {
	var uri = '/music/file/'+this.title.replace('file://localhost/', '');
	
	var title = artist = album = genre = '';
	try { title = this.childNodes[1].firstChild.data; } catch(e) {}
	try { artist = this.childNodes[2].firstChild.data; } catch (e) {}
	try { album = this.childNodes[3].firstChild.data; } catch (e) {}
 	try { genre = this.childNodes[4].firstChild.data; } catch (e) {}

	songlist[songlist.length] = {'uri':uri, 'title': title, 'artist': artist, 'album': album, 'genre': genre};
	setSong(songlist[songlist.length-1]);
	lastElement = this;
}

window.addEventListener("load", iTunesInit, false);

Object.prototype.swapWithNode = function (node) {
	var newParent = node.parentNode;
	var next = node.nextSibling;
	this.parentNode.insertBefore(node, this);
	
	if (next) newParent.insertBefore(this, next);
	else newParent.appendChild(this);
}

// ================
// = Media Player =
// ================

function MediaPlayer(element) {
	var self = this;
	var performedSongEndingActions = false;
	this.element = element;
	this.song = null;
	this.timer = null;
	this.songEndedCallback = null;
	
	function media () {
		// Return the object if in Safari, the embed in other browsers
		var arr = self.element.getElementsByTagName(navigator.userAgent.match("WebKit") ? 'object':'embed');
		if (!arr || !arr.length) return null;
		return arr[0];
	}
	
	function poll () {
		if (!self.element) return;
		if (!media()) return;
		if (!self.isPlayable()) return;
		
		if (self.time() == self.duration())
		{
			if(!performedSongEndingActions)
			{
				performedSongEndingActions = true;
				if (self.songEndedCallback) self.songEndedCallback(self);
			}
		}
		else
		{
			if (performedSongEndingActions) performedSongEndingActions = false;
		}
	}
	
	this.setSong = function(song) {
		this.song = song
		performedSongEndingActions = false;
		if (!media()) {
			var object = document.createElement("object");
			var src = document.createElement("param");
			src.setAttribute('name', "src");
			src.setAttribute('value', song);
			object.appendChild(src);
			var embed = document.createElement("embed");
			embed.setAttribute('src', song);
			embed.setAttribute('EnableJavaScript', 'true');
			object.appendChild(embed);
			this.element.appendChild(object);
		}
		else { media().SetURL(song); }
	}

	
	this.timer = setInterval(poll, 250);
	
	// Media player functions can be found by searching Google with "javascript Play() site:apple.com" and looking through the QuickTime documentation
	
	this.play = function() { media().Play(); }
	this.stop = function() { media().Stop(); }
	this.pause = function() { media().Pause(); }
	this.rewind = function () { media().Rewind(); }
	this.step = function (count) { media().Step(count); }
	this.isPlayable = function() { 
		var m = media();
		if (!m) return false;
		try {
			return this.status().match("Playable") || this.status().match("Complete");
		}
		catch (e) {}
		return false;
	}
	
	this.status = function() { return media().GetPluginStatus(); }
	this.duration = function() { return media().GetDuration(); }
	this.timeScale = function() { return media().GetTimeScale(); }
	this.size = function() { return media().GetMovieSize(); }
	
	this.willAutoplay = function() { return media().GetAutoPlay(); }
	this.setAutoplay = function(autoplay) { media().SetAutoPlay(autoplay); }
	
	this.isControllerVisisble = function() { return media().GetControllerVisible(); }
	this.setControllerVisible = function(visible) { media().SetControllerVisible(visible); }
	
	this.rate = function() { return media().GetRate(); }
	this.setRange = function(rate) { media().SetRate(rate); }
	
	this.time = function() { return media().GetTime(); }
	this.setTime = function(time) { media().setTime(time); }
	
	this.volume = function() { return media().GetVolume(); }
	this.setVolume = function(volume) { media().SetVolume(volume); }
	
	this.isMute = function() { return media().GetMute(); }
	this.mute = function() { media().SetMute(true); }
	this.unmute = function() { media().SetMute(false); }
	this.toggleMute = function() { media().SetMute(!this.isMute); }
	
	this.movieName = function() { return media().GetMovieName(); }
	this.setMovieName = function(name) { media().SetMovieName(name); }
	
	this.movieID = function() { return media().GetMovieID(); }
	this.setMovieID = function(id) { media().SetMovieID(id); }
	
	this.startTime = function() { return media().GetStartTime(); }
	this.setStartTime = function(start) { media().SetStartTime(start); }
	
	this.endTime = function() { return media().GetEndTime(); }
	this.setEndTime = function(end) { media().SetEndTime(end); }
	
	// Doesn't appear to work
	this.bgColor = function() { return media().GetBgColor(); }
	this.setBgColor = function(color) { media().SetBgColor(color); }
	
	this.media = media;
}
